#include <stdlib.h>
#include <stdio.h>
#include <librnpl.h>

#define CHUNK_SIZE (1024*1024)

main(int argc, char **argv)
{
	BBH_I shape[1],lev,*start,nlvls,nv,res;
	BBH_D time,*data,*coords,*tvec,*x,*y,*tv;
	BBH_C **cnames,*nm;
	
	if(argc != 2){
		fprintf(stderr,"Usage: hdftovs fname_stem\n");
		exit(1);
	}
	if(!gft_read_shape(argv[1],1,shape)){
		fprintf(stderr,"hdftovs: Can't read shape from <%s>\n",argv[1]);
		exit(1);
	}
	nv=CHUNK_SIZE/shape[0];
	if(nv==0){
		fprintf(stderr,"hdftovs: vector too long.\n");
		exit(1);
	}
	x=vec_alloc(CHUNK_SIZE);
	y=vec_alloc(CHUNK_SIZE);
	start=ivec_alloc(nv+1);
	tvec=vec_alloc(nv);
	cnames=(BBH_C **)malloc(sizeof(BBH_C *)*1);
	if(!cnames){
		fprintf(stderr,"hdftovs: Can't get memory for cnames\n");
		exit(1);
	}
	cnames[0]=(BBH_C *)malloc(sizeof(BBH_C)*10);
	if(!cnames[0]){
		fprintf(stderr,"hdftovs: Can't get memory for cnames[0]\n");
		exit(1);
	}
	for(lev=0;lev<nv;lev++)
		start[lev]=lev*shape[0]+1;
	start[lev]=1;
	data=y;
	coords=x;
	if(!gft_read_full(argv[1],1,shape,cnames,1,&time,coords,data)){
		fprintf(stderr,"hdftovs: Can't read first time level\n");
		exit(1);
	}
	if((nm=gft_make_full_func_name(argv[1],1,cnames))==NULL){
		fprintf(stderr,"hdftovs: Can't make func_name\n");
		exit(1);
	}
	lev=1;
	do{
		data=y;
		coords=x;
		tv=tvec;
		nlvls=0;
		do{
			if(res=gft_read_full(argv[1],lev,shape,cnames,1,tv,coords,data)){
				tv++;
				data+=shape[0];
				coords+=shape[0];
				lev++,nlvls++;
			}
		}while(nlvls<nv-1 && res);
		vsmxynt(nm,start,tvec,nlvls,x,y);
	}while(res);
	gft_close_all();
	free(nm);
	free(x);
	free(y);
	free(start);
	free(tvec);
}
